<?php

namespace snowaAnsar\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpwSalesInventoryAndPrice ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSpwSalesInventoryAndPrice
 * @subpackage Arrays
 */
class ArrayOfSpwSalesInventoryAndPrice extends AbstractStructArrayBase
{
    /**
     * The SpwSalesInventoryAndPrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \snowaAnsar\StructType\SpwSalesInventoryAndPrice[]
     */
    public $SpwSalesInventoryAndPrice;
    /**
     * Constructor method for ArrayOfSpwSalesInventoryAndPrice
     * @uses ArrayOfSpwSalesInventoryAndPrice::setSpwSalesInventoryAndPrice()
     * @param \snowaAnsar\StructType\SpwSalesInventoryAndPrice[] $spwSalesInventoryAndPrice
     */
    public function __construct(array $spwSalesInventoryAndPrice = array())
    {
        $this
            ->setSpwSalesInventoryAndPrice($spwSalesInventoryAndPrice);
    }
    /**
     * Get SpwSalesInventoryAndPrice value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \snowaAnsar\StructType\SpwSalesInventoryAndPrice[]|null
     */
    public function getSpwSalesInventoryAndPrice()
    {
        return isset($this->SpwSalesInventoryAndPrice) ? $this->SpwSalesInventoryAndPrice : null;
    }
    /**
     * Set SpwSalesInventoryAndPrice value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \snowaAnsar\StructType\SpwSalesInventoryAndPrice[] $spwSalesInventoryAndPrice
     * @return \snowaAnsar\ArrayType\ArrayOfSpwSalesInventoryAndPrice
     */
    public function setSpwSalesInventoryAndPrice(array $spwSalesInventoryAndPrice = array())
    {
        foreach ($spwSalesInventoryAndPrice as $arrayOfSpwSalesInventoryAndPriceSpwSalesInventoryAndPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpwSalesInventoryAndPriceSpwSalesInventoryAndPriceItem instanceof \snowaAnsar\StructType\SpwSalesInventoryAndPrice) {
                throw new \InvalidArgumentException(sprintf('The SpwSalesInventoryAndPrice property can only contain items of \snowaAnsar\StructType\SpwSalesInventoryAndPrice, "%s" given', is_object($arrayOfSpwSalesInventoryAndPriceSpwSalesInventoryAndPriceItem) ? get_class($arrayOfSpwSalesInventoryAndPriceSpwSalesInventoryAndPriceItem) : gettype($arrayOfSpwSalesInventoryAndPriceSpwSalesInventoryAndPriceItem)), __LINE__);
            }
        }
        if (is_null($spwSalesInventoryAndPrice) || (is_array($spwSalesInventoryAndPrice) && empty($spwSalesInventoryAndPrice))) {
            unset($this->SpwSalesInventoryAndPrice);
        } else {
            $this->SpwSalesInventoryAndPrice = $spwSalesInventoryAndPrice;
        }
        return $this;
    }
    /**
     * Add item to SpwSalesInventoryAndPrice value
     * @throws \InvalidArgumentException
     * @param \snowaAnsar\StructType\SpwSalesInventoryAndPrice $item
     * @return \snowaAnsar\ArrayType\ArrayOfSpwSalesInventoryAndPrice
     */
    public function addToSpwSalesInventoryAndPrice(\snowaAnsar\StructType\SpwSalesInventoryAndPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \snowaAnsar\StructType\SpwSalesInventoryAndPrice) {
            throw new \InvalidArgumentException(sprintf('The SpwSalesInventoryAndPrice property can only contain items of \snowaAnsar\StructType\SpwSalesInventoryAndPrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SpwSalesInventoryAndPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \snowaAnsar\StructType\SpwSalesInventoryAndPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \snowaAnsar\StructType\SpwSalesInventoryAndPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \snowaAnsar\StructType\SpwSalesInventoryAndPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \snowaAnsar\StructType\SpwSalesInventoryAndPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \snowaAnsar\StructType\SpwSalesInventoryAndPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SpwSalesInventoryAndPrice
     */
    public function getAttributeName()
    {
        return 'SpwSalesInventoryAndPrice';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \snowaAnsar\ArrayType\ArrayOfSpwSalesInventoryAndPrice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
