<?php

namespace snowaAnsar\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderBuffer StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:OrderBuffer
 * @subpackage Structs
 */
class OrderBuffer extends AbstractStructBase
{
    /**
     * The CompleteAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CompleteAddress;
    /**
     * The CustomerId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $CustomerId;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Description;
    /**
     * The GeographicRegionId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $GeographicRegionId;
    /**
     * The GoodsId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $GoodsId;
    /**
     * The PostalCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PostalCode;
    /**
     * The Quantity
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $Quantity;
    /**
     * The ReceiptionCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ReceiptionCode;
    /**
     * The SellerId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $SellerId;
    /**
     * The StoreScopeId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $StoreScopeId;
    /**
     * The TrackingNo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TrackingNo;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - ref: ser:Id
     * @var string
     */
    public $Id;
    /**
     * The Ref
     * Meta informations extracted from the WSDL
     * - ref: ser:Ref
     * @var string
     */
    public $Ref;
    /**
     * Constructor method for OrderBuffer
     * @uses OrderBuffer::setCompleteAddress()
     * @uses OrderBuffer::setCustomerId()
     * @uses OrderBuffer::setDescription()
     * @uses OrderBuffer::setGeographicRegionId()
     * @uses OrderBuffer::setGoodsId()
     * @uses OrderBuffer::setPostalCode()
     * @uses OrderBuffer::setQuantity()
     * @uses OrderBuffer::setReceiptionCode()
     * @uses OrderBuffer::setSellerId()
     * @uses OrderBuffer::setStoreScopeId()
     * @uses OrderBuffer::setTrackingNo()
     * @uses OrderBuffer::setId()
     * @uses OrderBuffer::setRef()
     * @param string $completeAddress
     * @param int $customerId
     * @param string $description
     * @param int $geographicRegionId
     * @param int $goodsId
     * @param string $postalCode
     * @param int $quantity
     * @param string $receiptionCode
     * @param int $sellerId
     * @param int $storeScopeId
     * @param string $trackingNo
     * @param string $id
     * @param string $ref
     */
    public function __construct($completeAddress = null, $customerId = null, $description = null, $geographicRegionId = null, $goodsId = null, $postalCode = null, $quantity = null, $receiptionCode = null, $sellerId = null, $storeScopeId = null, $trackingNo = null, $id = null, $ref = null)
    {
        $this
            ->setCompleteAddress($completeAddress)
            ->setCustomerId($customerId)
            ->setDescription($description)
            ->setGeographicRegionId($geographicRegionId)
            ->setGoodsId($goodsId)
            ->setPostalCode($postalCode)
            ->setQuantity($quantity)
            ->setReceiptionCode($receiptionCode)
            ->setSellerId($sellerId)
            ->setStoreScopeId($storeScopeId)
            ->setTrackingNo($trackingNo)
            ->setId($id)
            ->setRef($ref);
    }
    /**
     * Get CompleteAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCompleteAddress()
    {
        return isset($this->CompleteAddress) ? $this->CompleteAddress : null;
    }
    /**
     * Set CompleteAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $completeAddress
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setCompleteAddress($completeAddress = null)
    {
        // validation for constraint: string
        if (!is_null($completeAddress) && !is_string($completeAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($completeAddress)), __LINE__);
        }
        if (is_null($completeAddress) || (is_array($completeAddress) && empty($completeAddress))) {
            unset($this->CompleteAddress);
        } else {
            $this->CompleteAddress = $completeAddress;
        }
        return $this;
    }
    /**
     * Get CustomerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getCustomerId()
    {
        return isset($this->CustomerId) ? $this->CustomerId : null;
    }
    /**
     * Set CustomerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $customerId
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: int
        if (!is_null($customerId) && !is_numeric($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->CustomerId);
        } else {
            $this->CustomerId = $customerId;
        }
        return $this;
    }
    /**
     * Get Description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescription()
    {
        return isset($this->Description) ? $this->Description : null;
    }
    /**
     * Set Description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $description
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->Description);
        } else {
            $this->Description = $description;
        }
        return $this;
    }
    /**
     * Get GeographicRegionId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getGeographicRegionId()
    {
        return isset($this->GeographicRegionId) ? $this->GeographicRegionId : null;
    }
    /**
     * Set GeographicRegionId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $geographicRegionId
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setGeographicRegionId($geographicRegionId = null)
    {
        // validation for constraint: int
        if (!is_null($geographicRegionId) && !is_numeric($geographicRegionId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($geographicRegionId)), __LINE__);
        }
        if (is_null($geographicRegionId) || (is_array($geographicRegionId) && empty($geographicRegionId))) {
            unset($this->GeographicRegionId);
        } else {
            $this->GeographicRegionId = $geographicRegionId;
        }
        return $this;
    }
    /**
     * Get GoodsId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getGoodsId()
    {
        return isset($this->GoodsId) ? $this->GoodsId : null;
    }
    /**
     * Set GoodsId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $goodsId
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setGoodsId($goodsId = null)
    {
        // validation for constraint: int
        if (!is_null($goodsId) && !is_numeric($goodsId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($goodsId)), __LINE__);
        }
        if (is_null($goodsId) || (is_array($goodsId) && empty($goodsId))) {
            unset($this->GoodsId);
        } else {
            $this->GoodsId = $goodsId;
        }
        return $this;
    }
    /**
     * Get PostalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPostalCode()
    {
        return isset($this->PostalCode) ? $this->PostalCode : null;
    }
    /**
     * Set PostalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $postalCode
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setPostalCode($postalCode = null)
    {
        // validation for constraint: string
        if (!is_null($postalCode) && !is_string($postalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($postalCode)), __LINE__);
        }
        if (is_null($postalCode) || (is_array($postalCode) && empty($postalCode))) {
            unset($this->PostalCode);
        } else {
            $this->PostalCode = $postalCode;
        }
        return $this;
    }
    /**
     * Get Quantity value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getQuantity()
    {
        return isset($this->Quantity) ? $this->Quantity : null;
    }
    /**
     * Set Quantity value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $quantity
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: int
        if (!is_null($quantity) && !is_numeric($quantity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($quantity)), __LINE__);
        }
        if (is_null($quantity) || (is_array($quantity) && empty($quantity))) {
            unset($this->Quantity);
        } else {
            $this->Quantity = $quantity;
        }
        return $this;
    }
    /**
     * Get ReceiptionCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReceiptionCode()
    {
        return isset($this->ReceiptionCode) ? $this->ReceiptionCode : null;
    }
    /**
     * Set ReceiptionCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $receiptionCode
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setReceiptionCode($receiptionCode = null)
    {
        // validation for constraint: string
        if (!is_null($receiptionCode) && !is_string($receiptionCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($receiptionCode)), __LINE__);
        }
        if (is_null($receiptionCode) || (is_array($receiptionCode) && empty($receiptionCode))) {
            unset($this->ReceiptionCode);
        } else {
            $this->ReceiptionCode = $receiptionCode;
        }
        return $this;
    }
    /**
     * Get SellerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getSellerId()
    {
        return isset($this->SellerId) ? $this->SellerId : null;
    }
    /**
     * Set SellerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $sellerId
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setSellerId($sellerId = null)
    {
        // validation for constraint: int
        if (!is_null($sellerId) && !is_numeric($sellerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sellerId)), __LINE__);
        }
        if (is_null($sellerId) || (is_array($sellerId) && empty($sellerId))) {
            unset($this->SellerId);
        } else {
            $this->SellerId = $sellerId;
        }
        return $this;
    }
    /**
     * Get StoreScopeId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getStoreScopeId()
    {
        return isset($this->StoreScopeId) ? $this->StoreScopeId : null;
    }
    /**
     * Set StoreScopeId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $storeScopeId
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setStoreScopeId($storeScopeId = null)
    {
        // validation for constraint: int
        if (!is_null($storeScopeId) && !is_numeric($storeScopeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($storeScopeId)), __LINE__);
        }
        if (is_null($storeScopeId) || (is_array($storeScopeId) && empty($storeScopeId))) {
            unset($this->StoreScopeId);
        } else {
            $this->StoreScopeId = $storeScopeId;
        }
        return $this;
    }
    /**
     * Get TrackingNo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTrackingNo()
    {
        return isset($this->TrackingNo) ? $this->TrackingNo : null;
    }
    /**
     * Set TrackingNo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $trackingNo
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setTrackingNo($trackingNo = null)
    {
        // validation for constraint: string
        if (!is_null($trackingNo) && !is_string($trackingNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($trackingNo)), __LINE__);
        }
        if (is_null($trackingNo) || (is_array($trackingNo) && empty($trackingNo))) {
            unset($this->TrackingNo);
        } else {
            $this->TrackingNo = $trackingNo;
        }
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Ref value
     * @return string|null
     */
    public function getRef()
    {
        return $this->Ref;
    }
    /**
     * Set Ref value
     * @param string $ref
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public function setRef($ref = null)
    {
        // validation for constraint: string
        if (!is_null($ref) && !is_string($ref)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ref)), __LINE__);
        }
        $this->Ref = $ref;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \snowaAnsar\StructType\OrderBuffer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
